const util = require('../../nodemodules/timerbox-utils/util.js');
const dateUtil = require('../../nodemodules/timerbox-utils/dateUtil.js');
/**
 * 时间小盒事件Bean
 * @param obj {String|Function}
 * @constructor
 */
function EventBO(obj) {
  if (typeof obj === 'string') {
    this.title = obj;
  } else if (typeof  obj === 'object') {
    initEvent.call(this, obj);
  } else if (typeof obj === 'function') {
    var result = obj(this);
    if (result) {
      initEvent.call(this, result);
    }
  }

  /**
   * 设置开始时间
   * @param time {Number|String}
   * @returns {EventBO}
   */
  this.setBeginTime = function (time) {
    this.beginTime = time;
    return this;
  };

  /**
   * 设置结束时间
   * @param time Number|String}
   * @returns {EventBO}
   */
  this.setEndTime = function (time) {
    this.endTime = time;
    return this;
  };
}

function initEvent(obj) {
  for (var key in obj) {
    this[key] = obj[key];
  }
}
/**
 * 处理并返回事件的时间文本
 * @param event_time 传入含有create_time的event_time对象
 * @returns {string} 返回事件时间描述文本
 */
function handleEventTime(event_time) {
    if (util.isVariableEmpty(event_time)) return ''

    if (event_time.hasOwnProperty('timeline_begin_time') && !util.isVariableEmpty(event_time.timeline_begin_time)) {
        var beginTimeStr = dateUtil.formatEventDetailTime(new Date(event_time.timeline_begin_time))
    }
    if (event_time.hasOwnProperty('timeline_end_time') && !util.isVariableEmpty(event_time.timeline_end_time)) {
        var endTimeStr = dateUtil.formatEventDetailTime(new Date(event_time.timeline_end_time))
    }

    if (event_time.hasOwnProperty('create_time') && event_time.create_time > 0) {
        var createTime = dateUtil.formatEventDetailTime(new Date(event_time.create_time))
    }

    var totalTimeStr = ''
    if (beginTimeStr == null && endTimeStr == null) {
        totalTimeStr = createTime + '创建'
    } else {
        if (beginTimeStr != null) {
            totalTimeStr = beginTimeStr
        }
        if (endTimeStr != null) {
            if (beginTimeStr != null) {
                totalTimeStr = beginTimeStr + ' - ' + endTimeStr
            } else {
                totalTimeStr = endTimeStr + '截止'
            }
        } else {
            totalTimeStr = totalTimeStr + '开始'
        }
    }

    return totalTimeStr
}
module.exports = {
    EventBO : EventBO,
    handleEventTime:handleEventTime,
}
// module.exports = EventBO;